using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace FiltronASP.Models.Validators
{
    /// <summary>
    /// Walidator sprawdzajacy czy wprowadzona wartosc jest nieujemna.
    /// </summary>
    [AttributeUsage(AttributeTargets.Field | AttributeTargets.Property, AllowMultiple = false)]
    public class NotNegativeNumberAttribute : ValidationAttribute
    {
        private const string _defaultErrorMessage = "Wprowadzona wartość powinna być nieujemna.";
        
        /// <summary>
        /// Konstruktor.
        /// </summary>  
        public NotNegativeNumberAttribute()
            : base(_defaultErrorMessage)
        {
        }

        /// <summary>
        /// Metoda walidujaca wprowadzona wartosc.
        /// </summary>
        /// <param name="value">wartosc podlegajaca walidacji</param>
        /// <returns>true, gdy przejdzie walidacje, false w przeciwnym razie</returns>
        public override bool IsValid(object value)
        {
            if (value == null)
            {
                return true;
            }   //if
            int intValue;
            if (int.TryParse(value.ToString(), out intValue))
            {
                if (intValue > 0)
                {
                    return true;
                }   //if
            }   //if
            return false;
        }
    }
}
